Follow up to r225203 refining break-to-debugger improvements:

(1) Add missed at91 UART driver
(2) Move BREAK_TO_DEBUGGER and ALT_BREAK_TO_DEBUGGER from opt_comconsole.h
    to opt_kdb.h (spotted by nadvdeep)
(3) Garbage collect opt_comconsole.h

Approved by:	re (XXX)

Index: arm/at91/uart_dev_at91usart.c
===================================================================
--- arm/at91/uart_dev_at91usart.c	(revision 225203)
+++ arm/at91/uart_dev_at91usart.c	(working copy)
@@ -29,8 +29,6 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_comconsole.h"
-
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/bus.h>
@@ -485,25 +483,10 @@
 static __inline void
 at91_rx_put(struct uart_softc *sc, int key)
 {
-#if defined(KDB) && defined(ALT_BREAK_TO_DEBUGGER)
-	int kdb_brk;
 
-	if (sc->sc_sysdev != NULL && sc->sc_sysdev->type == UART_DEV_CONSOLE) {
-		if ((kdb_brk = kdb_alt_break(key, &sc->sc_altbrk)) != 0) {
-			switch (kdb_brk) {
-			case KDB_REQ_DEBUGGER:
-				kdb_enter(KDB_WHY_BREAK,
-				    "Break sequence on console");
-				break;
-			case KDB_REQ_PANIC:
-				kdb_panic("Panic sequence on console");
-				break;
-			case KDB_REQ_REBOOT:
-				kdb_reboot();
-				break;
-			}
-		}
-	}
+#if defined(KDB)
+	if (sc->sc_sysdev != NULL && sc->sc_sysdev->type == UART_DEV_CONSOLE)
+		kdb_alt_break(key, &sc->sc_altbrk);
 #endif
 	uart_rx_put(sc, key);	
 }
Index: powerpc/mambo/mambo_console.c
===================================================================
--- powerpc/mambo/mambo_console.c	(revision 225203)
+++ powerpc/mambo/mambo_console.c	(working copy)
@@ -25,8 +25,6 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_comconsole.h"
-
 #include <sys/param.h>
 #include <sys/kdb.h>
 #include <sys/kernel.h>
Index: conf/options
===================================================================
--- conf/options	(revision 225203)
+++ conf/options	(working copy)
@@ -47,6 +47,8 @@
 TWA_FLASH_FIRMWARE	opt_twa.h
 
 # Debugging options.
+ALT_BREAK_TO_DEBUGGER	opt_kdb.h
+BREAK_TO_DEBUGGER	opt_kdb.h
 DDB
 DDB_BUFR_SIZE	opt_ddb.h
 DDB_CAPTURE_DEFAULTBUFSIZE	opt_ddb.h
@@ -637,9 +639,6 @@
 BKTR_USE_FREEBSD_SMBUS		opt_bktr.h
 BKTR_NEW_MSP34XX_DRIVER		opt_bktr.h
 
-BREAK_TO_DEBUGGER	opt_comconsole.h
-ALT_BREAK_TO_DEBUGGER	opt_comconsole.h
-
 # Options to support PPS
 UART_PPS_ON_CTS		opt_uart.h
 
Index: modules/dcons/Makefile
===================================================================
--- modules/dcons/Makefile	(revision 225203)
+++ modules/dcons/Makefile	(working copy)
@@ -5,7 +5,7 @@
 
 KMOD	= dcons
 SRCS	= dcons.c dcons.h dcons_os.c dcons_os.h \
-		opt_dcons.h opt_kdb.h opt_ddb.h opt_gdb.h opt_comconsole.h
+		opt_dcons.h opt_kdb.h opt_ddb.h opt_gdb.h
 
 .if !defined(KERNBUILDDIR)
 opt_kdb.h:
@@ -13,9 +13,6 @@
 
 opt_ddb.h:
 	echo "#define DDB 1" > $@
-
-opt_comconsole.h:
-	echo "#define ALT_BREAK_TO_DEBUGGER 1" > $@
 .endif
 
 CFLAGS+= -I${.CURDIR}/../.. 
Index: modules/sio/Makefile
===================================================================
--- modules/sio/Makefile	(revision 225203)
+++ modules/sio/Makefile	(working copy)
@@ -7,7 +7,7 @@
 
 KMOD=	sio
 SRCS=	bus_if.h card_if.h device_if.h isa_if.h pci_if.h serdev_if.h \
-	opt_comconsole.h opt_compat.h opt_gdb.h opt_kdb.h opt_sio.h \
+	opt_compat.h opt_gdb.h opt_kdb.h opt_sio.h \
 	sio.c sio_pccard.c sio_pci.c sio_puc.c pccarddevs.h
 .if ${MACHINE} == "pc98"
 SRCS+=	sio_cbus.c
Index: dev/uart/uart_core.c
===================================================================
--- dev/uart/uart_core.c	(revision 225203)
+++ dev/uart/uart_core.c	(working copy)
@@ -27,10 +27,6 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#ifndef KLD_MODULE
-#include "opt_comconsole.h"
-#endif
-
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/bus.h>
Index: dev/sio/sio.c
===================================================================
--- dev/sio/sio.c	(revision 225203)
+++ dev/sio/sio.c	(working copy)
@@ -33,7 +33,6 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_comconsole.h"
 #include "opt_compat.h"
 #include "opt_gdb.h"
 #include "opt_kdb.h"
Index: dev/cfe/cfe_console.c
===================================================================
--- dev/cfe/cfe_console.c	(revision 225203)
+++ dev/cfe/cfe_console.c	(working copy)
@@ -27,8 +27,6 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_comconsole.h"
-
 #include <sys/param.h>
 #include <sys/kdb.h>
 #include <sys/kernel.h>
Index: dev/dcons/dcons_os.c
===================================================================
--- dev/dcons/dcons_os.c	(revision 225203)
+++ dev/dcons/dcons_os.c	(working copy)
@@ -64,7 +64,6 @@
 #include <vm/vm_param.h>
 #include <vm/pmap.h>
 
-#include "opt_comconsole.h"
 #include "opt_dcons.h"
 #include "opt_kdb.h"
 #include "opt_gdb.h"
Index: dev/ofw/ofw_console.c
===================================================================
--- dev/ofw/ofw_console.c	(revision 225203)
+++ dev/ofw/ofw_console.c	(working copy)
@@ -26,7 +26,6 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_comconsole.h"
 #include "opt_ofw.h"
 
 #include <sys/param.h>
Index: pc98/cbus/sio.c
===================================================================
--- pc98/cbus/sio.c	(revision 225203)
+++ pc98/cbus/sio.c	(working copy)
@@ -31,7 +31,6 @@
  *	from: i386/isa sio.c,v 1.234
  */
 
-#include "opt_comconsole.h"
 #include "opt_compat.h"
 #include "opt_gdb.h"
 #include "opt_kdb.h"
Index: ddb/db_break.c
===================================================================
--- ddb/db_break.c	(revision 225203)
+++ ddb/db_break.c	(working copy)
@@ -35,8 +35,6 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_comconsole.h"
-
 #include <sys/param.h>
 
 #include <vm/vm.h>